> For clean Markdown content of this page, append .md to this URL. For the complete documentation index, see https://learning.postman.com/llms.txt. For full content including API reference and SDK examples, see https://learning.postman.com/llms-full.txt.

# Get a spec's definition

GET https://api.getpostman.com/specs/{specId}/definitions

Gets the complete contents of an OpenAPI or AsyncAPI specification's definition.

Reference: https://learning.postman.com/api-docs/api-reference/specs/get-spec-definition

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Postman API
  version: 1.0.0
paths:
  /specs/{specId}/definitions:
    get:
      operationId: getSpecDefinition
      summary: Get a spec's definition
      description: >-
        Gets the complete contents of an OpenAPI or AsyncAPI specification's
        definition.
      tags:
        - specs
      parameters:
        - name: specId
          in: path
          description: The spec's ID.
          required: true
          schema:
            $ref: '#/components/schemas/specId'
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Specs_getSpecDefinition_Response_200'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetSpecDefinitionRequestForbiddenError'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/GetSpecDefinitionRequestInternalServerError
servers:
  - url: https://api.getpostman.com
    description: https://api.getpostman.com
  - url: https://api.eu.postman.com
    description: https://api.eu.postman.com
components:
  schemas:
    specId:
      type: string
      title: specId
    Specs_getSpecDefinition_Response_200:
      type: object
      properties: {}
      description: Empty response body
      title: Specs_getSpecDefinition_Response_200
    CommonErrorTypeTitleDetailStatusType:
      oneOf:
        - type: string
          format: uri-reference
        - type: string
      title: CommonErrorTypeTitleDetailStatusType
    commonErrorTypeTitleDetailStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailStatusType'
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: Information about the error.
        status:
          type: integer
          description: The error's HTTP status code.
      title: commonErrorTypeTitleDetailStatus
    commonErrorTypeTitleDetailStatusInstance:
      type: object
      properties:
        type:
          type: string
          format: uri-reference
          description: >-
            The [URI reference](https://www.rfc-editor.org/rfc/rfc3986) that
            identifies the type of problem.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: An explanation about the problem.
        status:
          type: integer
          description: The HTTP status code generated by the origin server.
        instance:
          type: string
          description: >-
            The URI reference that identifies the specific occurrence of the
            problem.
      title: commonErrorTypeTitleDetailStatusInstance
    GetSpecDefinitionRequestForbiddenError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatusInstance'
      title: GetSpecDefinitionRequestForbiddenError
    CommonErrorTypeTitleDetailDetail:
      oneOf:
        - type: string
        - type: object
          additionalProperties:
            description: Any type
      description: Information about the error.
      title: CommonErrorTypeTitleDetailDetail
    commonErrorTypeTitleDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailDetail'
          description: Information about the error.
      title: commonErrorTypeTitleDetail
    CommonErrorNameMessageError:
      type: object
      properties:
        name:
          type: string
          description: The error name.
        message:
          type: string
          description: The error message.
      description: Information about the error.
      title: CommonErrorNameMessageError
    commonErrorNameMessage:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/CommonErrorNameMessageError'
          description: Information about the error.
      title: commonErrorNameMessage
    GetSpecDefinitionRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: GetSpecDefinitionRequestInternalServerError
  securitySchemes:
    PostmanApiKey:
      type: apiKey
      in: header
      name: x-api-key
    scimApiKey:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        A valid [SCIM API
        key](https://learning.postman.com/docs/administration/scim-provisioning/scim-provisioning-overview/#generating-scim-api-key)
        for calls to SCIM endpoints.
    basicAuth:
      type: http
      scheme: basic

```

## Examples



**Response**

```json
"{\n    \"openapi\": \"3.0.0\",\n    \"servers\": [\n        {\n            \"url\": \"example.com\"\n        }\n    ],\n    \"info\": {\n        \"contact\": {\n            \"name\": \"\"\n        },\n        \"version\": \"1.0.0\",\n        \"title\": \"Sample API\",\n        \"description\": \"Buy or rent spacecrafts\"\n    },\n    \"paths\": {\n        \"/spacecrafts/{spacecraftId}\": {\n            \"parameters\": [\n                {\n                    \"name\": \"spacecraftId\",\n                    \"description\": \"The unique identifier of the spacecraft\",\n                    \"in\": \"path\",\n                    \"required\": true,\n                    \"schema\": {\n                        \"$ref\": \"#/components/schemas/SpacecraftId\"\n                    }\n                }\n            ],\n            \"get\": {\n                \"summary\": \"Read a spacecraft\",\n                \"responses\": {\n                    \"200\": {\n                        \"description\": \"The spacecraft corresponding to the provided `spacecraftId`\",\n                        \"content\": {\n                            \"application/json\": {\n                                \"schema\": {\n                                    \"$ref\": \"#/components/schemas/Spacecraft\"\n                                }\n                            }\n                        }\n                    },\n                    \"404\": {\n                        \"description\": \"No spacecraft found for the provided `spacecraftId`\",\n                        \"content\": {\n                            \"application/json\": {\n                                \"schema\": {\n                                    \"$ref\": \"#/components/schemas/Error\"\n                                }\n                            }\n                        }\n                    },\n                    \"500\": {\n                        \"description\": \"Unexpected error\",\n                        \"content\": {\n                            \"application/json\": {\n                                \"schema\": {\n                                    \"$ref\": \"#/components/schemas/Error\"\n                                }\n                            }\n                        }\n                    }\n                }\n            },\n            \"post\": {\n                \"summary\": \"A short summary of what the operation does.\",\n                \"responses\": {\n                    \"200\": {\n                        \"description\": \"A short description of the response.\",\n                        \"content\": {\n                            \"application/json\": {\n                                \"schema\": {\n                                    \"type\": \"string\"\n                                }\n                            }\n                        }\n                    }\n                }\n            }\n        },\n        \"/pathName\": {\n            \"summary\": \"A short summary intended to apply to all operations in this path.\",\n            \"get\": {\n                \"summary\": \"A short summary of what the operation does.\",\n                \"responses\": {\n                    \"200\": {\n                        \"description\": \"A short description of the response.\",\n                        \"content\": {\n                            \"application/json\": {\n                                \"schema\": {\n                                    \"type\": \"string\"\n                                }\n                            }\n                        }\n                    }\n                }\n            }\n        }\n    },\n    \"components\": {\n        \"schemas\": {\n            \"SpacecraftId\": {\n                \"description\": \"The unique identifier of a spacecraft\",\n                \"type\": \"string\"\n            },\n            \"Spacecraft\": {\n                \"type\": \"object\",\n                \"required\": [\n                    \"id\",\n                    \"name\",\n                    \"type\"\n                ],\n                \"properties\": {\n                    \"id\": {\n                        \"$ref\": \"#/components/schemas/SpacecraftId\"\n                    },\n                    \"name\": {\n                        \"type\": \"string\"\n                    },\n                    \"type\": {\n                        \"type\": \"string\",\n                        \"enum\": [\n                            \"capsule\",\n                            \"probe\",\n                            \"satellite\",\n                            \"spaceplane\",\n                            \"station\"\n                        ]\n                    },\n                    \"description\": {\n                        \"type\": \"string\"\n                    }\n                }\n            },\n            \"Error\": {\n                \"type\": \"object\",\n                \"required\": [\n                    \"message\"\n                ],\n                \"properties\": {\n                    \"message\": {\n                        \"description\": \"A human readable error message\",\n                        \"type\": \"string\"\n                    }\n                }\n            }\n        },\n        \"securitySchemes\": {\n            \"ApiKey\": {\n                \"type\": \"apiKey\",\n                \"in\": \"header\",\n                \"name\": \"X-Api-Key\"\n            }\n        }\n    },\n    \"security\": [\n        {\n            \"ApiKey\": []\n        }\n    ]\n}"
```

**SDK Code**

```python Successful JSON Response
import requests

url = "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions"

headers = {"x-api-key": "<apiKey>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript Successful JSON Response
const url = 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions';
const options = {method: 'GET', headers: {'x-api-key': '<apiKey>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Successful JSON Response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Successful JSON Response
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["x-api-key"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java Successful JSON Response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions")
  .header("x-api-key", "<apiKey>")
  .asString();
```

```php Successful JSON Response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions', [
  'headers' => [
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Successful JSON Response
using RestSharp;

var client = new RestClient("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions");
var request = new RestRequest(Method.GET);
request.AddHeader("x-api-key", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift Successful JSON Response
import Foundation

let headers = ["x-api-key": "<apiKey>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/definitions")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```